//+------------------------------------------------------------------+
//|                                                       tiger.mq4  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, zeshan tayyab malick, June 21st 2014"
#property link      "zmalick@hotmail.com"

extern double price_ma_period_fast =21; //slow ma
extern double price_ma_period_slow =89; //fast ma 
double LotSize; //lotsize
extern double LotFactor = 2; //lotsize factor
extern double StopLoss=5000; //stop loss
extern double TakeProfit=70; //take profit
extern int MagicNumber=1234; //magic
extern double pips = 0.00001; //leave as default for 5 digit brokers
extern double adxthreshold = 27; //adx threshold - must be greater than this to trade
extern double adxperiod = 14; //adx period
extern double rsiperiod = 14; //rsi period
extern double rsiupper = 65; //rsi upper bound, wont buy above this value
extern double rsilower = 35; //rsi lower bound, wont sell below this value

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   if ( IsNewCandle() )
   {
      trenddirection(); //find trend direction
      logic(); //apply indicator logic
      Lot_Volume(); //calc lotsize
      buyorsell(); //trade - buy or sell
   
   
      return(0);
     }
  return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//insuring its a new candle function
//+------------------------------------------------------------------+
bool IsNewCandle()
{
/*   static int BarsOnChart=0;
   if (Bars == BarsOnChart)
   return (false);
   BarsOnChart = Bars;
   return(true);*/
  if (Bars == 0) return (false); else return (True);  
}
//+------------------------------------------------------------------+
//identifies the direction of the current trend
//+------------------------------------------------------------------+
bool trenddirection()
{
   double pricefastmanow,priceslowmanow;
   pricefastmanow = iMA(Symbol(),0,price_ma_period_fast,0,MODE_EMA,PRICE_CLOSE,0);
   priceslowmanow = iMA(Symbol(),0,price_ma_period_slow,0,MODE_EMA,PRICE_CLOSE,0);
   return (pricefastmanow > priceslowmanow);  //bullish if true, bearish if false
}
//+------------------------------------------------------------------+
//applies logic from indicators ADX and RSI to determine if we can trade
//+------------------------------------------------------------------+
int logic()
{
   double adx,rsi;   
   adx = iADX(Symbol(),0,adxperiod,PRICE_CLOSE,MODE_MAIN,0);
   rsi = iRSI(Symbol(),0,rsiperiod,PRICE_CLOSE,0);
   return ( (adx > adxthreshold) && ((rsi > rsilower && rsi < rsiupper)) );
}
//+------------------------------------------------------------------+
//opens trades
//+------------------------------------------------------------------+
int buyorsell()
{
   bool trenddirectionx, logicx;
   int TicketNumber;
   
   trenddirectionx = trenddirection();
   logicx = logic();

   if (OrdersTotal() ==0)
   {
     if (logicx)
     {
       if (trenddirectionx)
         //buy
         TicketNumber = OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,Ask-(StopLoss*pips),Ask+(TakeProfit*pips),NULL,MagicNumber,0,Green);
       else
         //sell
         TicketNumber = OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,Bid+(StopLoss*pips),Bid-(TakeProfit*pips),NULL,MagicNumber,0,Red);
     }
   }

return(0);

}

//+------------------------------------------------------------------+
//calculates lot size based on balance and factor
//+------------------------------------------------------------------+
double Lot_Volume()
{
   double lot, min_lot, max_lot;

   lot = AccountBalance() / 2500;

   LotSize = lot / LotFactor;

   min_lot = MarketInfo( Symbol(), MODE_MINLOT );
   max_lot = MarketInfo( Symbol(), MODE_MAXLOT );

   if( LotSize < min_lot ) LotSize = min_lot;  // prevent error 131 : INVALID_TRADE_VOLUME
   if( LotSize > max_lot ) LotSize = max_lot;  // prevent error 131 : INVALID_TRADE_VOLUME
   
   LotSize = NormalizeDouble( LotSize, 2 );

   return( LotSize );
}